stages:
  - test
  - build
  - deploy

.dependency_install: &dependency_install
  image: node:lts
  before_script:
    - npm ci --registry https://nexus-manager.revelup.com/repository/npm-all/
    - npm install

Run tests:
  stage: test
  <<: *dependency_install
  only:
    - merge_request
    - master
  script:
    - npm test

Build packages:
  stage: build
  <<: *dependency_install
  only:
    - merge_request
    - master
  script:
    - npm run build
  artifacts:
    paths:
      - build
    expire_in: 1 hour

Deploy packages:
  <<: *dependency_install
  stage: deploy
  only:
    - master
  script:
    - token=$(echo $NEXUS_NPM_TOKEN | base64 -d)
    - echo "//nexus-manager.revelup.com/repository/npm-internal/:_authToken=$token" >> ~/.npmrc
    - npm publish
